;;; erlang-site-start.el --- Site start script for Erlang mode

;; Copyright (C) 2003  Free Software Foundation, Inc.

;; Author: Alex Ott <ott@localhost>
;; Keywords: Erlang

(autoload 'erlang-mode "erlang" "erlang mode autoload" t)
(setq auto-mode-alist
      (cons '("\\.erl$" . erlang-mode)
	    auto-mode-alist))

(setq-default erlang-root-dir "/usr/lib/erlang")
(setq-default erlang-man-dirs
	      '(("Man - Commands" "/usr/share/man/man1" nil)
		("Man - Modules" "/usr/share/man/man3" nil)
		))


(add-hook 'erlang-shell-mode-hook
          '(lambda ()
             (split-window)))

(add-hook 'erlang-mode-hook 'site-erlang-mode-hook)
(defun site-erlang-mode-hook ()
  (local-set-key "\\C-c\\C-c" 'erlang-compile)
  (if window-system
      (progn
	(setq font-lock-maximum-decoration t)
	(font-lock-mode 1)))
  (if (and window-system (fboundp 'imenu-add-to-menubar))
      (imenu-add-to-menubar "Imenu")))


;;; erlang-site-start.el ends here
