Name: erlang
Version: R11B
Release: alt2

Summary: A programming language developed by Ericsson
License: EPL
Group: Development/Other

Packager: Mikhail Yakshin <greycat@altlinux.org>

Url: http://www.erlang.org

Source: otp_src_R11B-3.tar.gz
Source1: otp_doc_man_R11B-3.tar.gz
Source2: otp_doc_html_R11B-3.tar.gz
Source3: %name.el
Source4: %name-site-start.el
Source5: README.erlang_mode
Source6: %name-dirs

BuildPreReq: /proc
BuildPreReq: emacs-common
BuildPreReq: gcc-c++ gcc libssl-devel libncurses-devel openssl flex
BuildPreReq: tk-devel j2se1.5-sun-devel zlib-devel libunixODBC-devel
BuildRequires: symlinks

%description
Erlang is a programming language developed at Ericsson Computer
Science Laboratory.  Erlang provides many features which are more
commonly associated with an operating system: concurrent processes,
scheduling, memory management, distribution, networking, etc.

%package megaco
Summary: H.248 support for Erlang
Group: Development/Other
Requires: %name = %version

%description megaco
Megaco (aka H.248) is a signalling protocol used in VoIP networks.
This package adds support for Megaco to your Erlang installation.

%package -n emacs-mode-erlang
Summary: Erlang mode for GNU Emacs
Group: Editors
Requires: emacs-base

%description -n emacs-mode-erlang
Erlang mode for GNU Emacs.

%package manual
Summary: Documentatinon for Erlang in HTML format
Group: Development/Other
Requires: %name = %version-%release

%description manual
Ducumentation for Erlang in HTML format.

%package manpages
Summary: Manual pages for Erlang
Group: Development/Other
Requires: %name = %version-%release

%description manpages
Manual pages for Erlang programming language.

%package visual
Summary: Standart visual applications for Erlang
Group: Development/Other
Requires: %name = %version-%release
Requires: tk

%description visual
Standard visual applications for Erlang programming language.

%package odbc
Summary: ODBC support for Erlang
Group: Development/Other
Requires: %name = %version-%release

%description odbc
ODBC support for Erlang programming language.

%prep
%setup -q -n otp_src_R11B-3
cp %SOURCE6 .
mkdir tmp
tar -C tmp -zxf %SOURCE1
tar -C tmp -zxf %SOURCE2

for i in $(cat erlang-dirs);do
    [ ! -d $i ] && mkdir -p $i
done

%build
#autoreconf -fisv
export CFLAGS="%optflags -fno-stack-protector -D_REENTRANT"
./configure \
            --prefix=%prefix \
            --libdir=%_libdir \
            --mandir=%_mandir \
            --enable-hipe \
            --disable-erlang-mandir \
            --with-ssl
# \
#            --disable-threads

%make

%install
%set_verify_elf_method textrel=relaxed
%add_findreq_skiplist %_libdir/%name/erts-*/bin/*

%make_install INSTALL_PREFIX=%buildroot install

mkdir -p %buildroot%_docdir/%name-%version/manual
mkdir -p %buildroot%_emacslispdir
mkdir -p %buildroot%_sysconfdir/emacs/site-start.d
mkdir -p %buildroot%_mandir

install -m644 %SOURCE3 %buildroot%_emacslispdir
install -m644 %SOURCE4 %buildroot/%_sysconfdir/emacs/site-start.d/erlang.el
install -m644 %SOURCE5 %buildroot%_docdir/%name-%version

cp EPLICENCE %buildroot%_docdir/%name-%version/LICENCE
cp AUTHORS %buildroot%_docdir/%name-%version/AUTHORS

mv tmp/{COPYRIGHT,PR.template,README} %buildroot%_docdir/%name-%version
mv tmp/man/* %buildroot%_mandir
mv tmp/* %buildroot%_docdir/%name-%version/manual

pushd .

cd %buildroot%_man3dir
for i in {lib,crypto,inet,ssl,queue,random,rpc,string,zlib}.3* ; do
  mv -f $i erl_$i
done

cd %buildroot%_man6dir
for i in {crypto,ssl,snmp}.6* ; do
  mv -f $i erl_$i
done

cd %buildroot%_emacslispdir
for i in *.el ; do
        emacs -batch --eval "(progn
		(setq load-path (append (list \".\")  load-path))
		(byte-compile-file \"$i\"))"
done

popd

# fixing absolute links
symlinks -cd \
	%buildroot%_bindir \
	%buildroot%_libdir/%name/bin \
	%buildroot%_libdir/%name/erts-*/bin
# fixing lengthy links
symlinks -sc \
	%buildroot%_bindir \
	%buildroot%_libdir/%name/bin \
	%buildroot%_libdir/%name/erts-*/bin

rm %buildroot%_libdir/%name/Install
rm -r %buildroot%_libdir/%name/misc
rm -r %buildroot%_libdir/%name/usr/lib
rm -r %buildroot%_libdir/%name/erts-*/{doc,man}

%__subst 's|ROOTDIR=.*|ROOTDIR=%_libdir/%name|'  \
	%buildroot%_libdir/%name/erts-*/bin/erl \
	%buildroot%_libdir/%name/erts-*/bin/start \
	%buildroot%_libdir/%name/bin/erl \
	%buildroot%_libdir/%name/bin/start

ln -s ../../share/man %buildroot%_libdir/%name/man

%files
%dir %_docdir/%name-%version
%_bindir/*
%_libdir/%name
%_docdir/%name-%version/*
%exclude %_docdir/%name-%version/manual
%exclude %_libdir/%name/lib/appmon-*
%exclude %_libdir/%name/lib/debugger-*
%exclude %_libdir/%name/lib/et-*
%exclude %_libdir/%name/lib/gs-*
%exclude %_libdir/%name/lib/pman-*
%exclude %_libdir/%name/lib/toolbar-*
%exclude %_libdir/%name/lib/tv-*
%exclude %_libdir/%name/lib/odbc-*
%exclude %_libdir/%name/lib/megaco-*

%files megaco
%_libdir/%name/lib/megaco-*

%files visual
%_libdir/%name/lib/appmon-*
%_libdir/%name/lib/debugger-*
%_libdir/%name/lib/et-*
%_libdir/%name/lib/gs-*
%_libdir/%name/lib/pman-*
%_libdir/%name/lib/toolbar-*
%_libdir/%name/lib/tv-*

%files -n emacs-mode-erlang
%_emacslispdir/*
%_sysconfdir/emacs/site-start.d/*

%files manual
%_docdir/%name-%version/manual

%files manpages
%_man1dir/*
%_man3dir/*
%_man4dir/*
%_man6dir/*

%files odbc
%_libdir/%name/lib/odbc-*

%changelog
* Tue Feb 20 2007 Mikhail Yakshin <greycat@altlinux.ru> R11B-alt2
- Fixed x86_64 build

* Sat Feb 10 2007 Mikhail Yakshin <greycat@altlinux.org> R11B-alt1
- R11B-3

* Fri Dec 29 2006 ALT QA Team Robot <qa-robot@altlinux.org> R10B.10-alt2.1
- Rebuilt due to libcrypto.so.4 -> libcrypto.so.6 soname change.

* Thu Oct 12 2006 Alex V. Myltsev <avm@altlinux.ru> R10B.10-alt2
- Merged with alb's version from backports.
- Applied the 'new glibc' patch.
- Moved zlib.3.gz to erl_zlib.3.gz.
- Moved Megaco to a separate package..

* Thu Sep 07 2006 Alexey Borovskoy <alb@altlinux.ru> R11B.1-alt0.M24.1
- New release (R11B-1).

* Wed Mar 22 2006 Alexey Borovskoy <alb@altlinux.ru> R10B.10-alt0.M24.1
- New release (R10B-10).

* Mon Dec 19 2005 Alexey Borovskoy <alb@altlinux.ru> R10B.9-alt0.M24.1
- New release (R10B-9).

* Sun Oct 30 2005 Alexey Borovskoy <alb@altlinux.ru> R10B.8-alt0.M24.2
- Add ODBC support.

* Fri Oct 28 2005 Alexey Borovskoy <alb@altlinux.ru> R10B.8-alt0.M24.1
- New release (R10B-8).
- Add patch for disable static linking with zlib. Does not work and disabled.
- Add zlib-devel buildtime dependency. But dymamic linking with zlib not
  supported in erts/emulator/dirvers/common/gzio.c due using private zutil.h.
- Remove --enable-threads due erl segfault.

* Thu Sep 08 2005 Alexey Borovskoy <alb@altlinux.ru> R10B.7-alt0.M24.1
- New release (R10B-7)

* Wed Aug 10 2005 Alexey Borovskoy <alb@altlinux.ru> R10B.6-alt0.M24.1
- New release (R10B-6)

* Wed May 11 2005 Alexey Borovskoy <alb@altlinux.ru> R10B.4-alt0.M24.1
- New release (R10B-4)
- Split to subpackages:
  + manual
    For manual in HTML
  + manpages
    For manpages
  + visual
    For visual apps that requires tk/tcl
  + emacs-mode-erlang
    For Emacs mode

* Tue Nov 02 2004 Plugnikov A. Mike <amike@altlinux.ru> R10B.0-alt1
- New version (R10B)
- Merged upstream patches:
  patch-lib_stdlib_src_dets__v9
  erlang_ssl_broker
- Fix spec

* Sat May 15 2004 Ott Alex <ott@altlinux.ru> R9C.0-alt3
- Fix build process

* Sun Feb 22 2004 Ott Alex <ott@altlinux.ru> R9C.0-alt2
- Added some fixes from freebsd ports (thanks to Ermine!)
- Build without tcl/tk & java

* Wed Dec 10 2003 Ott Alex <ott@altlinux.ru> R9C.0-alt1
- Initial build for ALTLinux

